#include "Status.h"
#include "Vram.h"
#include "Main.h"
#include "Sprite.h"
#include "Print.h"
#include "Chars.h"

static word PrintS(word vram, ptr<byte> p, bool right)
{
    byte c;
    while ((c = *p) != 0) {
        vram = PrintC(vram, c, right);
        right = !right;
        ++p;
    }
    return vram;
}

void PrintStatus() 
{
    PrintS(Vram + 0, "SC", false);   
    // PrintS(Vram + 7 * VramStep, "HI-SCORE");
    PrintS(Vram + 4, "ST", true);
    PrintByteNumber2(Vram + 5, CurrentStage + 1, true);
    PrintC(Vram+ 7, 'T', false);
    {
        word vram;
        vram = Vram + 10;
        if (RemainCount > 1) {
            byte i;
            i = RemainCount - 1;
            do {
                byte c;
                c = Char_Man;
                repeat (2) {
                    bool right;
                    right = false;
                    repeat (2) {
                        vram = Put(vram, c, right);
                        right = !right;
                        ++c;
                    }
                    vram += VramRowSize - 1;
                }
                vram += 1 - VramRowSize * 2;
                --i;
            } while (i > 0);
        }
    }
    PrintScore();
    PrintTime();
}

void PrintScore()
{
    word vram;
    vram = PrintNumber5(Vram + 1, Score, false);
    PrintC(vram, '0', true);
}

void PrintTime()
{
    word vram;
    vram = PrintByteNumber3(Vram + 7, StageTime, true);
    PrintC(vram, ' ', false);
}

void PrintGameOver()
{
    PrintS(Vram + VramRowSize * 9 + 3, "GAME OVER", true);
}

void PrintTimeUp() 
{
    PrintS(Vram + VramRowSize * 9 + 4, "TIME UP", false);
}

void Title()
{
    static const byte[] TitleBytes = {
        //	L
        0x0c, 0x03, 0x00, 0x00, 
        0x0c, 0x03, 0x00, 0x00, 
        0x0c, 0x03, 0x00, 0x00, 
        0x04, 0x05, 0x05, 0x01, 
        //	I
        0x04, 0x0d, 0x07, 0x01, 
        0x00, 0x0c, 0x03, 0x00, 
        0x00, 0x0c, 0x03, 0x00, 
        0x04, 0x05, 0x05, 0x01, 
        //	F
        0x0c, 0x07, 0x05, 0x01, 
        0x0c, 0x0b, 0x0a, 0x02, 
        0x0c, 0x03, 0x00, 0x00, 
        0x04, 0x01, 0x00, 0x00, 
        //	T
        0x04, 0x0d, 0x07, 0x01, 
        0x00, 0x0c, 0x03, 0x00, 
        0x00, 0x0c, 0x03, 0x00, 
        0x00, 0x04, 0x01, 0x00, 
    };

    ClearScreen(); 
    HideAllSprites();
    PrintStatus(); 
    {
        ptr<byte> p;
        word vram;
        vram = Vram + VramRowSize * 2 + 2;
        p = TitleBytes;
        repeat (4) {
            repeat (4) {
                bool right;
                right = false;
                repeat (4) {
                    vram = Put(vram, *p, right);
                    right = !right;
                    ++p;
                }
                vram += VramRowSize - 2;
            }
            vram += 2 - VramRowSize * 4;
        }
        PrintS(Vram + VramRowSize * 6 + 8, "MINI", false);
    }

    PrintS(Vram + VramRowSize * 10 + 2, "PUSH SPACE KEY", false);
    PrintS(Vram + VramRowSize * 12 + 2, "OR RETURN KEY", false);
    PrintS(Vram + VramRowSize * 14 + 6, "INUFUTO 2023", false);

    // PresendVram();
}